/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-calibration-launch-1.0.6-0quantal-20150809-0901/srv/FkTest.srv
 *
 */


#ifndef PR2_CALIBRATION_LAUNCH_MESSAGE_FKTESTRESPONSE_H
#define PR2_CALIBRATION_LAUNCH_MESSAGE_FKTESTRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_calibration_launch
{
template <class ContainerAllocator>
struct FkTestResponse_
{
  typedef FkTestResponse_<ContainerAllocator> Type;

  FkTestResponse_()
    : pos()
    , rot()  {
    }
  FkTestResponse_(const ContainerAllocator& _alloc)
    : pos(_alloc)
    , rot(_alloc)  {
    }



   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _pos_type;
  _pos_type pos;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _rot_type;
  _rot_type rot;




  typedef boost::shared_ptr< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct FkTestResponse_

typedef ::pr2_calibration_launch::FkTestResponse_<std::allocator<void> > FkTestResponse;

typedef boost::shared_ptr< ::pr2_calibration_launch::FkTestResponse > FkTestResponsePtr;
typedef boost::shared_ptr< ::pr2_calibration_launch::FkTestResponse const> FkTestResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_calibration_launch

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e2248c2f30c5f3e010ed2e9434015c6e";
  }

  static const char* value(const ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe2248c2f30c5f3e0ULL;
  static const uint64_t static_value2 = 0x10ed2e9434015c6eULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_calibration_launch/FkTestResponse";
  }

  static const char* value(const ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64[] pos\n\
float64[] rot\n\
\n\
";
  }

  static const char* value(const ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pos);
      stream.next(m.rot);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct FkTestResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_calibration_launch::FkTestResponse_<ContainerAllocator>& v)
  {
    s << indent << "pos[]" << std::endl;
    for (size_t i = 0; i < v.pos.size(); ++i)
    {
      s << indent << "  pos[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.pos[i]);
    }
    s << indent << "rot[]" << std::endl;
    for (size_t i = 0; i < v.rot.size(); ++i)
    {
      s << indent << "  rot[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.rot[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_CALIBRATION_LAUNCH_MESSAGE_FKTESTRESPONSE_H
